import threading
import time
import datetime
import sys
from os.path import dirname, realpath, sep
import xbmcaddon
import xbmc
import xbmcgui
import xbmcplugin
import os

PLUGIN_ID = 'plugin.video.polbox.tv'

addon = xbmcaddon.Addon(id=PLUGIN_ID)

sys.path.append(dirname(realpath(__file__)) + sep + "resources" + sep + "lib")

import iptv
import re

__settings__ = xbmcaddon.Addon(id=PLUGIN_ID)

USERNAME = __settings__.getSetting('username')
USERPASS = __settings__.getSetting('password')
handle = int(sys.argv[1])

PLUGIN_NAME = 'PolBox.TV'
plugin = None
TRANSSID = ''

thumb = os.path.join(addon.getAddonInfo('path'), "icon.png")


def get_params():
    param = []
    paramstring = sys.argv[2]
    xbmc.log('[%s] parsing params from %s' % (PLUGIN_NAME, paramstring))
    if len(paramstring) >= 2:
        params = sys.argv[2]
        cleanedparams = params.replace('?', '')
        if (params[len(params) - 1] == '/'):
            params = params[0:len(params) - 2]
        pairsofparams = cleanedparams.split('&')
        param = {}
        for i in range(len(pairsofparams)):
            splitparams = {}
            splitparams = pairsofparams[i].split('=')
            if (len(splitparams)) == 2:
                param[splitparams[0]] = splitparams[1]
    return param


INFOTIMER_SHOW = None
INFOTIMER_HIDE = None

VIDEOTEKA = 'SelectGenre'
if __settings__.getSetting('old_videolib') == 'true':
    VIDEOTEKA = 'SelectGenre'  # used to be VIDEOTEKA = 'Video'

def Archive(plugin, id, params):
    uri = sys.argv[0]

    in_arch = False

    dt = None
    if 'dt' in params:
        dt = datetime.datetime.fromordinal(int(params['dt']))
        in_arch = True

    if not dt:
        dt = datetime.datetime.today()

    epg = plugin.getEPG(id, dt.strftime('%d%m%y'))

    xbmc.log('[%s] Archive/EPG: fetching EPG from %s as %s' %
             (PLUGIN_NAME, id, epg))

    day_ago = datetime.datetime.fromordinal(int(dt.toordinal()) - 1)
    goback_title = '[B][ %s ][/B]' % (day_ago.strftime('%a, %d %B'))
    goback = xbmcgui.ListItem(goback_title)
    goback.setLabel(goback_title)
    goback.setProperty('IsPlayable', 'false')
    goback.setInfo(type='video', infoLabels={
        'title': goback_title, 'plot': 'Go to previous day'})
    uri = sys.argv[0] + '?mode=Archive&channel=%s&dt=%s&can_play=%s' % (
        id, day_ago.toordinal(), params['can_play'])
    xbmc.log(uri)
    xbmcplugin.addDirectoryItem(handle, uri, goback, True)
    currentProg = False

    counter = 0
    for prog in epg:
        counter = counter + 1
        progStart = int(prog['time'])
        timeLabel = datetime.datetime.fromtimestamp(
            progStart + plugin.timeshift).strftime('%H:%M')
        can_play = params['can_play']

        if can_play:
            if progStart > time.time():
                can_play = False

        title = '%s %s %s' % (timeLabel, prog['title'], prog['info'])

        if progStart < time.time():
            if currentProg == False:
                if len(epg) > counter:
                    p = epg[counter]
                    if int(p['time']) > time.time():
                        title = '[B][COLOR green]%s[/COLOR][/B]' % title
                        currentProg = counter
            pass
        else:
            title = '[I]%s[/I]' % title

        item = xbmcgui.ListItem(title)
        item.setLabel(title)
        item.setLabel2(prog['info'])
        item.setInfo(type='video', infoLabels={
            'title': prog['title'], 'plot': prog['info']})
        uri = ''

        if can_play:
            item.setProperty('IsPlayable', 'true')
            # item.setIconImage(os.path.join(addon.getAddonInfo(
            #    'path'), 'resources', 'icons', 'play.png'))
            uri = sys.argv[0] + '?mode=WatchTV&channel=%s&title=%s&ts=%s' % (
                id, prog['title'], prog['time'])
        else:
            # item.setIconImage(os.path.join(addon.getAddonInfo(
            #    'path'), 'resources', 'icons', 'play-stop.png'))
            item.setProperty('IsPlayable', 'false')

        xbmcplugin.addDirectoryItem(handle, uri, item, False)

    day_forward = datetime.datetime.fromordinal(int(dt.toordinal()) + 1)
    goahead_title = '[B][ %s ][/B]' % (day_forward.strftime('%a, %d %B'))
    goahead = xbmcgui.ListItem(goahead_title)
    goahead.setLabel(goahead_title)
    goahead.setProperty('IsPlayable', 'false')
    goahead.setInfo(type='video', infoLabels={
        'title': goahead_title, 'plot': 'Go to next day'})
    uri = sys.argv[0] + '?mode=Archive&channel=%s&dt=%s&can_play=%s' % (
        id, day_forward.toordinal(), params['can_play'])
    xbmc.log(uri)
    xbmcplugin.addDirectoryItem(handle, uri, goahead, True)

    xbmcplugin.endOfDirectory(handle, True, in_arch)
    # xbmc.executebuiltin( "Container.SetViewMode(51)")
    if currentProg:
        try:
            win = xbmcgui.Window(xbmcgui.getCurrentWindowId())
            win.getControl(win.getFocusId()).selectItem(currentProg + 1)
        except:
            xbmc.log('[%s] cannot to select %s item', PLUGIN_NAME, currentProg)


def resetAlarms(plugin, mode):
    refreshAlarmId = '%s_refresh_list' % PLUGIN_ID
    xbmc.executebuiltin("XBMC.CancelAlarm(%s,True)" % refreshAlarmId)
    resetInfoTimers()


def ShowChannelsList(plugin, mode='TV'):
    refreshAlarmId = '%s_refresh_list' % PLUGIN_ID

    channels = plugin.getChannelsList()
    counter = 0
    favs = __settings__.getSetting('favourites').split(',')

    if len(favs) < 2:
        mode = 'TV'

    xbmc.PlayList(xbmc.PLAYLIST_VIDEO).clear()

    total_items = len(channels)

    for channel in channels:

        # skip hd channels if eco mode enabled
        if __settings__.getSetting("bitrate") == "900" and re.search(" HD( \-\d+)?$", channel['title']):
            continue

        if __settings__.getSetting('show_protected') == 'false':
            if channel['is_protected']:
                continue

        if mode == 'FAV':
            if str(channel['id']) not in favs:
                continue

        if channel['is_video']:
            uri = sys.argv[0] + '?mode=WatchTV&as=%s&channel=%s&title=%s' % (
                mode,
                channel['id'],
                channel['title']
            )

            if channel['is_protected']:
                uri = '%s&code=xxx' % (uri)
                overlay = 3
            else:
                if channel['have_archive']:
                    overlay = 1  # does not work
                else:
                    overlay = 0

            if str(channel['id']) in favs:
                overlay = 7

            item = xbmcgui.ListItem(channel['subtitle'],
                                    channel['title'],
                                    # iconImage=channel['icon'],
                                    # thumbnailImage=channel['icon']
                                    )
            item.setArt({'poster': channel['icon']})

            color = channel['color']

            if __settings__.getSetting('show_played') != 'false' and channel['duration']:
                played = ' [%s%%]' % channel['percent']
            else:
                played = ''

            timerange = ''
            timeFieldSetting = int(__settings__.getSetting('show_time_field'))

            if timeFieldSetting == 1:
                if channel['epg_start']:
                    channel['duration'] = int(
                        datetime.datetime.fromtimestamp(channel['epg_start']).strftime('%H')) * 60 + int(
                        datetime.datetime.fromtimestamp(channel['epg_start']).strftime('%M'))
                else:
                    channel['duration'] = 0
            elif timeFieldSetting == 2:
                if channel['epg_end']:
                    channel['duration'] = int(
                        datetime.datetime.fromtimestamp(channel['epg_end']).strftime('%H')) * 60 + int(
                        datetime.datetime.fromtimestamp(channel['epg_end']).strftime('%M'))
                else:
                    channel['duration'] = 0
            elif timeFieldSetting == 3:
                pass
            elif timeFieldSetting == 4:
                if channel['epg_end']:
                    channel['duration'] = (channel['epg_end'] - channel['servertime']) / 60
                else:
                    channel['duration'] = 0
            elif timeFieldSetting == 5:
                if channel['epg_start']:
                    timerange = '%s - %s ' % (
                        datetime.datetime.fromtimestamp(channel['epg_start']).strftime('%H:%M'),
                        datetime.datetime.fromtimestamp(channel['epg_end']).strftime('%H:%M')
                    )
                    channel['duration'] = 0
            else:
                channel['duration'] = 0

            rating = 0
            if str(channel['id']) in favs:
                rating = 10

            archiveIcon = ''

            if __settings__.getSetting('mark_archive') == 'true':
                if (channel['have_archive']):
                    # some way to indicate program has archive
                    archiveIcon = '*'

            if __settings__.getSetting('colorize_groups') == 'false':
                channel_title = channel['title']
            else:
                channel_title = '[COLOR %s]%s[/COLOR]' % (
                    color, channel['title'])

            label = '%s[B]%s %s.%s[/B] %s %s' % (
                timerange, archiveIcon, channel_title, played, channel['subtitle'], channel['info'])
            item.setLabel(label)

            # item.setIconImage(channel['icon'])

            item.setInfo(type='video',
                         infoLabels={
                             'title': channel['subtitle'],
                             'plotoutline': channel['info'],
                             'plot': channel['info'],
                             'genre': channel['genre'],
                             'duration': str(channel['duration']),
                             'overlay': overlay,
                             'ChannelNumber': str(counter),
                             'ChannelName': channel['title'],
                             'StartTime': datetime.datetime.fromtimestamp(
                                 channel['epg_start']).strftime('%H:%M'),
                             'EndTime': datetime.datetime.fromtimestamp(
                                 channel['epg_end']).strftime('%H:%M'),
                             'rating': rating
                         })

            item.setProperty('IsPlayable', 'true')

            if 'aspect_ratio' in channel and channel['aspect_ratio']:
                item.setProperty('AspectRatio', channel['aspect_ratio'])

            popup = []

            if channel['have_epg'] != False:
                archive_text = 'EPG'
                if channel['have_archive']:
                    archive_text = 'EPG and Archive'

                uri2 = sys.argv[0] + '?mode=Archive&channel=%s&can_play=%s' % (
                    channel['id'], channel['have_archive'])
                popup.append(
                    (archive_text, 'XBMC.Container.Update(%s)' % uri2))

            popup.append(('Refresh', 'Container.Refresh',))

            uri2 = sys.argv[0] + '?mode=Favourite&channel=%s' % (channel['id'])
            if str(channel['id']) in favs:
                fav_label = 'Remove from favourites'
            else:
                fav_label = 'Add to favourites'
            popup.append((fav_label, 'RunPlugin(%s)' % uri2))

            if __settings__.getSetting('start_with_tv') == 'true':
                uriP = 'XBMC.Container.Update(%s)' % (sys.argv[0] + '?mode=%s')
                if mode == 'TV':
                    popup.append(('Favourites only', uriP % 'FAV',))

                if mode == 'FAV':
                    popup.append(('All TV channels', uriP % 'TV',))

                popup.append(('Video collection', uriP % VIDEOTEKA,))
                popup.append(('Account settings', uriP % 'Settings',))

            item.addContextMenuItems(popup, True)

            xbmcplugin.addDirectoryItem(handle, uri, item, False, total_items)
            counter = counter + 1

    refresh_rate = int(__settings__.getSetting('autorefresh_rate'))

    xbmcplugin.setContent(handle, 'Movies')
    xbmcplugin.endOfDirectory(handle, cacheToDisc=(__settings__.getSetting('always_refresh') == 'false'))

    if refresh_rate > 0:
        xbmc.executebuiltin("XBMC.AlarmClock(%s,XBMC.Container.Refresh,%s,True)" % (refreshAlarmId, refresh_rate))


def SelectGenres(plugin, params):
    xbmc.log('Select genres screen initiated')
    glist = plugin.getGenresList()

    for genre in glist['genres']:
        title = genre['name']
        item = xbmcgui.ListItem(title)
        uri = sys.argv[0] + '?mode=Video&genre=%s' % (genre['id'])
        xbmcplugin.addDirectoryItem(handle, uri, item, True)

    xbmcplugin.endOfDirectory(handle, True, False)


def Video(plugin, params):
    if 'mode' in params:
        mode = params['mode']
    else:
        mode = 'last'

    if 'page' in params:
        page = int(params['page'])
        if page < 1:
            page = 1
    else:
        page = 1

    genreParam = ''
    genre = None
    if 'genre' in params:
        genre = params['genre']
        genreParam = '&genre=%s' % genre

    if page > 1:
        goback_title = '[ %s ]' % 'Previous page'
        goback = xbmcgui.ListItem(goback_title)
        goback.setLabel(goback_title)
        goback.setProperty('IsPlayable', 'false')
        goback.setInfo(type='video', infoLabels={'title': goback_title})
        uri = sys.argv[0] + \
              '?mode=Video&mode=%s&page=%d%s' % (mode, page - 1, genreParam)
        xbmc.log(uri)
        xbmcplugin.addDirectoryItem(handle, uri, goback, True)

    vlist = plugin.getVideoList(mode, page, genre, 'all')

    for film in vlist:
        title = film['title']
        item = xbmcgui.ListItem(
            title,
            title,
            # iconImage=film['icon'],
            # thumbnailImage=film['icon']
        )
        item.setLabel(title)
        # item.setIconImage(film['icon'])
        item.setLabel2(film['info'])
        item.setInfo(type='video', infoLabels={
            'title': title, 'plot': film['info']})
        uri = sys.argv[0] + '?mode=VideoInfo&vod=%s' % film['id']
        item.setProperty('IsPlayable', 'true')
        xbmcplugin.addDirectoryItem(handle, uri, item, True)

    goahead_title = '[ %s ]' % 'Next page'
    goahead = xbmcgui.ListItem(goahead_title)
    goahead.setLabel(goahead_title)
    goahead.setProperty('IsPlayable', 'false')
    goahead.setInfo(type='video', infoLabels={'title': goahead_title})
    uri = sys.argv[0] + \
          '?mode=Video&mode=%s&page=%d%s' % (mode, page + 1, genreParam)

    if (vlist):
        if len(vlist) > 49:
            xbmcplugin.addDirectoryItem(handle, uri, goahead, True)

    xbmcplugin.endOfDirectory(handle, True, False)


def VideoInfo(plugin, params):
    vid = params['vod']
    film = plugin.getVideoInfo(vid, __settings__.getSetting('protected_code'))

    for video in film['videos']:
        if not 'title' in video or video['title'] is None or len(video['title']) == 0:
            continue
        
        if __settings__.getSetting("bitrate") == "900" and re.search("^HD$", video['title']):
            continue

        title = video['title']

        poster = 'http://online.polbox.tv%s' % film['poster']

        xbmc.log('poster url = %s' % poster)

        item = xbmcgui.ListItem(
            title,
            title
        )
        item.setLabel(title)

        item.setArt({'poster': poster})
        item.setLabel2(film['description'])

        item.setInfo(type='video',
                     infoLabels={
                         'title': title,
                         'plot': film['description']
                     })
        item.setProperty('IsPlayable', 'true')
        uri = sys.argv[0] + '?mode=WatchVOD&vod=%s&title=%s' % (
            video['id'],
            film['name'] + '. ' + title
        )
        xbmcplugin.addDirectoryItem(handle, uri, item, False)

    xbmcplugin.endOfDirectory(handle)


def WatchVOD(plugin, params):
    vod = params['vod']
    url = plugin.getVideoUrl(vod, __settings__.getSetting('protected_code'))
    item = xbmcgui.ListItem(params['title'], path=url)
    item.setInfo(type='video', infoLabels={'title': params['title']})
    if handle == -1:
        xbmc.Player().play(url, item)
    else:
        xbmcplugin.setResolvedUrl(handle=handle, succeeded=True, listitem=item)


def WatchTV(plugin, id, params):    
    if 'ts' in params:
        gmt = params['ts']
    else:
        gmt = None

    if gmt:
        if __settings__.getSetting('ask_adjust') == 'true':
            adjust_text = 'Jump to specific time from beginning'
            dialogus = xbmcgui.Dialog()
            adjust = dialogus.numeric(2, adjust_text, "00:00")
            if adjust:
                a_hours, a_mins = adjust.split(':', 1)
                gmt = int(gmt) + (int(a_hours) * 3600 + int(a_mins) * 60)

    if 'code' in params:
        code = __settings__.getSetting('protected_code')
    else:
        code = -1

    url = plugin.getStreamUrl(id, gmt, code)

    if url == "protected":
        dialog = xbmcgui.Dialog()
        code = dialog.input('Enter parent code:', type=xbmcgui.INPUT_NUMERIC, option=xbmcgui.ALPHANUM_HIDE_INPUT)
        if code is None or len(code) == 0:
            code = -1
        
        __settings__.setSetting('protected_code', code)

        params['code'] = code
        WatchTV(plugin, id, params)
        
    else:
        if url:
            item = xbmcgui.ListItem(params['title'], path=url)
            item.setInfo(type='video', infoLabels={
                'title': params['title']
            })

            if 'as' in params:
                mode = params['as']
            else:
                mode = 'TV'

            favs = __settings__.getSetting('favourites').split(',')

            if len(favs) < 2:
                mode = 'TV'

            doVidInfo = False

            player = xbmc.Player()
            pls = xbmc.PlayList(xbmc.PLAYLIST_VIDEO)
            xbmcplugin.setContent(handle, 'Movies')
            if gmt:
                pls.clear()
            if not gmt and pls.size() < 2:
                pls.clear()
                all = plugin.getLast()
                index = 0
                toplay = -1

                for channel in all:

                    xbmc.log('[subtitle=%s, title=%s]' % (channel['subtitle'], channel['title']))

                    if not 'subtitle' in channel or channel['subtitle'] is None or len(channel['subtitle']) == 0:
                        continue

                    if mode == 'FAV' and str(channel['id']) not in favs:
                        index += 1
                        continue

                    if channel['is_video']:
                        if toplay > -1 or id == str(channel['id']):
                            url2 = sys.argv[0] + '?mode=WatchTV&as=%s&channel=%s&title=%s' % (
                                mode,
                                channel['id'],
                                channel['title']
                            )

                            code = __settings__.getSetting('protected_code')
                            if code is None:
                                xbmc.log("code is none!!!")
                                code = -1

                            url2 = '%s&code=%s' % (url2, code)

                            if id == str(channel['id']):
                                path = url
                            else:
                                path = url2

                            ch = xbmcgui.ListItem(channel['subtitle'], channel['title'])
                            ch.setArt({'poster': channel['icon']})

                            ch.setInfo(type='video',
                                       infoLabels={
                                           'Studio': channel['title'],
                                           'title': channel['subtitle'],
                                           'plot': channel['info'],
                                           'genre': channel['genre'],
                                           'ChannelName': channel['title'],
                                           'StartTime': datetime.datetime.fromtimestamp(channel['epg_start']).strftime(
                                               '%H:%M'),
                                           'EndTime': datetime.datetime.fromtimestamp(channel['epg_end']).strftime('%H:%M')
                                       })

                            ch.setProperty('IsPlayable', 'true')

                            if 'aspect_ratio' in channel and channel['aspect_ratio']:
                                ch.setProperty('AspectRatio', channel['aspect_ratio'])
                            elif __settings__.getSetting('guess_aspect_ratio'):
                                if channel['subtitle'].find('16:9') > -1 or channel['info'].find('16:9') > -1:
                                    ch.setProperty('AspectRatio', '1.20 : 1')
                            pls.add(path, ch, index)

                            if id == str(channel['id']):
                                item.setArt({'poster': channel['icon']})
                                item.setInfo(type='video',
                                             infoLabels={
                                                 'Studio': channel['title'],
                                                 'title': channel['subtitle'],
                                                 'plot': channel['info'],
                                                 'genre': channel['genre'],
                                                 'ChannelName': channel['title'],
                                                 'StartTime': datetime.datetime.fromtimestamp(
                                                     channel['epg_start']).strftime('%H:%M'),
                                                 'EndTime': datetime.datetime.fromtimestamp(channel['epg_end']).strftime(
                                                     '%H:%M')
                                             })

                                if 'aspect_ratio' in channel and channel['aspect_ratio']:
                                    ch.setProperty('AspectRatio', channel['aspect_ratio'])
                                elif __settings__.getSetting('guess_aspect_ratio'):
                                    if channel['subtitle'].find('16:9') > -1 or channel['info'].find('16:9') > -1:
                                        item.setProperty('AspectRatio', '1.20 : 1')
                                toplay = index
                        index += 1

                for channel in all[0:toplay]:

                    if mode == 'FAV' and str(channel['id']) not in favs:
                        continue
                    if channel['is_video']:
                        url2 = sys.argv[0] + '?mode=WatchTV&as=%s&channel=%s&title=%s' % (
                            mode, channel['id'], channel['title'])
                        if channel['is_protected']:
                            url2 = '%s&code=%s' % (url2, 'xxx')
                        path = url2
                        ch = xbmcgui.ListItem(channel['subtitle'], channel['title'])
                        ch.setArt({'poster': channel['icon']})
                        ch.setInfo(type='video',
                                   infoLabels={
                                       'Studio': channel['title'],
                                       'title': channel['subtitle'],
                                       'plot': channel['info'],
                                       'genre': channel['genre'],
                                       'ChannelName': channel['title'],
                                       'StartTime': datetime.datetime.fromtimestamp(channel['epg_start']).strftime('%H:%M'),
                                       'EndTime': datetime.datetime.fromtimestamp(channel['epg_end']).strftime('%H:%M')
                                   })

                        ch.setProperty('IsPlayable', 'true')
                        if 'aspect_ratio' in channel and channel['aspect_ratio']:
                            ch.setProperty('AspectRatio', channel['aspect_ratio'])
                        elif __settings__.getSetting('guess_aspect_ratio'):
                            if channel['subtitle'].find('16:9') > -1 or channel['info'].find('16:9') > -1:
                                ch.setProperty('AspectRatio', '1.20 : 1')
                        pls.add(path, ch, index)
                        index += 1
                doVidInfo = True
            elif not gmt:
                all = plugin.getLast()
                for channel in all:
                    if id == str(channel['id']):
                        item.setArt({'poster': channel['icon']})
                        item.setInfo(type='video',
                                     infoLabels={
                                         'Studio': channel['title'],
                                         'title': channel['subtitle'],
                                         'plot': channel['info'],
                                         'genre': channel['genre']
                                     })
                        if 'aspect_ratio' in channel and channel['aspect_ratio']:
                            item.setProperty('AspectRatio', channel['aspect_ratio'])
                        elif __settings__.getSetting('guess_aspect_ratio'):
                            if channel['subtitle'].find('16:9') > -1 or channel['info'].find('16:9') > -1:
                                item.setProperty('AspectRatio', '1.20 : 1')
                        break
                doVidInfo = True

            xbmc.executebuiltin("XBMC.PlayerControl(repeatall)")

            if handle == -1:
                if pls and pls.size():
                    player.play(pls)
                else:
                    player.play(url, item)
            else:
                xbmcplugin.setResolvedUrl(handle=handle, succeeded=True, listitem=item)

            if __settings__.getSetting('showcurrent') == 'true' and not gmt and doVidInfo:
                SetupInfoTimer()
        else:
            xbmc.executebuiltin("XBMC.Notification(" + 'Error receiving translation URL'.encode(
                'utf8') + ", " + 'Error receiving translation URL'.encode('utf8') + ", 8000)")


def resetInfoTimers():
    if INFOTIMER_SHOW:
        if INFOTIMER_SHOW.isAlive():
            INFOTIMER_SHOW.cancel()
    if INFOTIMER_HIDE:
        if INFOTIMER_HIDE.isAlive():
            INFOTIMER_HIDE.cancel()


def SetupInfoTimer():
    resetInfoTimers()
    INFOTIMER_SHOW = threading.Timer(10.0, ShowNowPlayingInfo)
    xbmc.log('[%s] Info timer is set' % (PLUGIN_NAME))
    INFOTIMER_SHOW.start()


def ShowNowPlayingInfo():
    resetInfoTimers()
    if xbmc.getCondVisibility('VideoPlayer.IsFullscreen'):
        INFOTIMER_HIDE = threading.Timer(6.0, HideNowPlayingInfo)
        xbmc.log('[%s] Showing info' % (PLUGIN_NAME))
        INFOTIMER_HIDE.start()
        dialog = xbmcgui.Window(10142)
        dialog.show()


def HideNowPlayingInfo():
    resetInfoTimers()
    xbmc.log('[%s] Hidding info' % (PLUGIN_NAME))
    xbmc.executebuiltin("Dialog.Close(10142)")


def ShowRoot():
    uri = sys.argv[0] + '?mode=%s'

    tv_title = ' [  %s  ] ' % 'TV'
    tv = xbmcgui.ListItem(tv_title)
    tv.setLabel(tv_title)
    tv.setProperty('IsPlayable', 'false')
    tv.setInfo(type='video', infoLabels={
        'title': tv_title, 'plot': 'TV'})
    xbmcplugin.addDirectoryItem(handle, uri % 'TV', tv, True)

    favs = __settings__.getSetting('favourites').split(',')
    if len(favs) > 1:
        fv_title = ' [  %s  ] ' % 'Favourites only'
        fv = xbmcgui.ListItem(fv_title)
        fv.setLabel(fv_title)
        fv.setProperty('IsPlayable', 'false')
        fv.setInfo(type='video', infoLabels={
            'title': fv_title, 'plot': 'Favourites only'})
        xbmcplugin.addDirectoryItem(handle, uri % 'FAV', fv, True)
    
    if plugin.getPacketName() != 'POLBOX-JUNIOR':
        vod_title = ' [  %s  ] ' % 'VOD'
        vod = xbmcgui.ListItem(vod_title)
        vod.setLabel(vod_title)
        vod.setProperty('IsPlayable', 'false')
        vod.setInfo(type='video', infoLabels={
            'title': vod_title, 'plot': 'VOD'})
        xbmcplugin.addDirectoryItem(handle, uri % VIDEOTEKA, vod, True)

    set_title = ' [  %s  ] ' % 'Account settings'
    set = xbmcgui.ListItem(set_title)
    set.setLabel(set_title)
    set.setProperty('IsPlayable', 'false')
    set.setInfo(type='video', infoLabels={
        'title': set_title, 'plot': 'Account settings'})
    xbmcplugin.addDirectoryItem(handle, uri % 'Settings', set, True)

    set_title = ' [  %s  ] ' % 'Settings'
    set = xbmcgui.ListItem(set_title)
    set.setLabel(set_title)
    set.setProperty('IsPlayable', 'false')
    set.setInfo(type='video', infoLabels={
        'title': set_title, 'plot': 'Settings'})
    xbmcplugin.addDirectoryItem(handle, uri % 'openSettings', set, True)
    xbmcplugin.endOfDirectory(handle, True, False)


def Favourite(plugin, id):
    favs = __settings__.getSetting('favourites').split(',')
    if not favs:
        favs = []
    if id not in favs:
        favs.append(id)
    else:
        favs.remove(id)
    __settings__.setSetting('favourites', ",".join(favs[:]))
    xbmc.executebuiltin("XBMC.Container.Refresh")


def ProcessSettings(plugin, params):
    if 'name' in params:

        value, options = plugin.getSettingCurrent(params['name'])
        dialog = xbmcgui.Dialog()
        selection = []
        for opval, opname in options:
            selection.append(opname)
        ret = dialog.select(params['title'], selection)
        counter = 0
        for opval, opname in options:
            if counter == ret:
                plugin.setSettingCurrent(params['name'], opval)
                __settings__.setSetting(params['name'], opval)
            
            counter = counter + 1
        xbmc.executebuiltin('Container.Refresh')

    else:

        settings = plugin.getSettingsList()

        uri = sys.argv[0] + '?mode=Settings&name=%s&title=%s'

        titles = {
            'stream_server': "Stream server",
            'timeshift': 'Timeshift',
            'bitrate': 'Bitrate',
            'timezone': 'Timezone'
        }

        for setting in settings:
            sName = titles[setting['name']]

            sItem = xbmcgui.ListItem(sName)
            sItem.setLabel(sName)
            sItem.setProperty('IsPlayable', 'false')
            sItem.setInfo(type='video', infoLabels={
                'title': sName,
                'plot': sName
            })
            xbmcplugin.addDirectoryItem(handle, uri % (
                setting['name'], 'Settings'), sItem, True)

        xbmcplugin.endOfDirectory(handle, True, False)


def ShowNowNextHint(plugin, chid):
    current = plugin.getCurrentInfo(chid)
    hint = ''
    first = 1
    for prog in current:
        if first:
            first = 0
            if 'title' in prog and prog['title'] != None:
                titl = 'Now'
                text = prog['title'].encode('utf8')
                xbmc.executebuiltin(
                    "XBMC.Notification(" + titl.encode('utf8') + ", " + text + ", 8000)")
                xbmc.sleep(8000)
        else:
            if 'title' in prog and prog['title'] != None:
                when = datetime.datetime.fromtimestamp(int(prog['time']))
                titl = 'Watch next on %s' % (when.strftime('%H:%M'))
                text = prog['title'].encode('utf8')
                xbmc.executebuiltin(
                    "XBMC.Notification(" + titl.encode('utf8') + ", " + text + ", 12000)")


def VideoLib(plugin, params):
    do = ''
    if 'do' in params:
        do = params['do']

    uri = sys.argv[0] + '?mode=VideoLib&do=%s'

    tv_title = ' [  %s  ] ' % 'Go to the video library'
    tv = xbmcgui.ListItem(tv_title)
    tv.setLabel(tv_title)
    tv.setProperty('IsPlayable', 'false')
    tv.setInfo(type='video', infoLabels={
        'title': tv_title, 'plot': 'Go to the video library'})
    xbmcplugin.addDirectoryItem(handle, uri % 'Play', tv, True)

    vod_title = ' [  %s  ] ' % 'VideoLibrary update'
    vod = xbmcgui.ListItem(vod_title)
    vod.setLabel(vod_title)
    vod.setProperty('IsPlayable', 'false')
    vod.setInfo(type='video', infoLabels={
        'title': vod_title, 'plot': 'Video collection'})
    xbmcplugin.addDirectoryItem(handle, uri % 'Update', vod, True)

    set_title = ' [  %s  ] ' % 'VideoLibrary cleanup'
    set = xbmcgui.ListItem(set_title)
    set.setLabel(set_title)
    set.setProperty('IsPlayable', 'false')
    set.setInfo(type='video', infoLabels={
        'title': set_title, 'plot': 'Account settings'})
    xbmcplugin.addDirectoryItem(handle, uri % 'Cleanup', set, True)

    xbmcplugin.endOfDirectory(handle, True, do != '')
    # xbmcplugin.endOfDirectory(handle,False,True)

    if do == 'Play':

        last_update = __settings__.getSetting(
            'video_last_update') or '0000-00-00 00:00:00'
        if last_update == '0000-00-00 00:00:00':
            dialog = xbmcgui.Dialog()
            if dialog.yesno('You have to index the video library first', 'Update the video library now?'):
                MovieLib(plugin, 'Update')

        elif last_update < datetime.datetime.fromtimestamp(time.time() - 60 * 60 * 24 * 7).strftime(
                '%Y-%m-%d %H:%M:%S'):
            dialog = xbmcgui.Dialog()
            if dialog.yesno('Last time video library was updated longer then week ago',
                            'Update the video library now?'):
                MovieLib(plugin, 'Update')

        smartPlsFile = xbmc.translatePath(
            'special://profile/playlists/video') + '/' + str(PLUGIN_ID) + '.xsp'
        xbmc.log('[%s] checking smart playlist at %s' %
                 (PLUGIN_NAME, smartPlsFile))
        if not os.path.exists(smartPlsFile):
            xbmc.log('[%s] smart playlist not found' % (PLUGIN_NAME))
            smartPls = open(smartPlsFile, "w")
            smartPls.write('''<?xml version="1.0" encoding="UTF-8" standalone="yes" ?>
                <smartplaylist type="movies">
                    <name>%s</name>
                    <match>all</match>
                    <rule field="path" operator="is">plugin://%s/</rule>
                </smartplaylist>''' % (PLUGIN_NAME, PLUGIN_ID))
            smartPls.close()

        xbmc.executebuiltin("XBMC.ActivateWindow(VideoLibrary,Movies)")
    elif do != '':
        xbmc.log('[%s] calling movielib %s' % (PLUGIN_NAME, do))
        MovieLib(plugin, do)


def MovieLib(plugin, do):
    import movielib
    m = movielib.movielib()

    if do == 'Cleanup':
        dialog = xbmcgui.Dialog()
        if dialog.yesno('VideoLibrary cleanup', 'Are you sure you want to remove all data from the video library?'):
            m.vdbCleanUp(sys.argv[0])
            __settings__.setSetting('video_last_update', '0000-00-00 00:00:00')
            __settings__.setSetting('in_vod', 'false')
            dialog = xbmcgui.Dialog()
            dialog.ok('VideoLibrary cleanup', 'Done')
    elif do == 'Update':
        __settings__.setSetting('in_vod', 'false')
        progress = xbmcgui.DialogProgress()
        progress.create('VideoLibrary update')
        progress.update(10, 'Receiving data')
        vlist = plugin.getVideoList('last', 1, 'all')
        progress.update(20, 'Preparing data')
        toprocess = []
        last_update = __settings__.getSetting(
            'video_last_update') or '0000-00-00 00:00:00'
        for vod in vlist:
            info = sys.argv[0] + '?mode=VideoInfo&vod=%s' % vod['id']
            if m.vdbMovieByPathAndTrailer(sys.argv[0], info):
                xbmc.log('[%s] skipping %s?' %
                         (PLUGIN_NAME, info), level=xbmc.LOGDEBUG)
                continue
            else:
                xbmc.log('[%s] new vod %s?' % (PLUGIN_NAME, info))
            toprocess.append(vod)
        if len(toprocess):
            stepSize = float(60.0 / len(toprocess))
        else:
            stepSize = 1
        xbmc.log('[%s] progress step size set to %s as 60 / %s' %
                 (PLUGIN_NAME, stepSize, len(toprocess)), level=xbmc.LOGDEBUG)
        counter = 0
        for vod in toprocess:
            # [glareff] i keep getting disconnected when indexing, so i added this line to run every 10 items processed
            if (counter % 10 < 1):
                xbmc.log('\nAuthenticating preventively\n')
                plugin._auth(plugin.login, plugin.password)
            info = plugin.getVideoInfo(vod['id'])
            film = movielib.movielibmovie(sys.argv[0])
            film.setTitle(vod['title'])
            film.setDescription(vod['info'])
            film.setImage(vod['icon'])
            for genre in vod['genre'].split(', '):
                film.addGenre(genre)
            for actor in info['actors'].split(', '):
                film.addActor(actor)
            film.setYear(info['year'])
            if info['rate_imdb']:
                rating = info['rate_imdb']
            else:
                rating = info['rate_kinopoisk']
            film.setRating(rating)
            film.setDirector(info['director'])
            film.setWritter(info['scenario'])
            film.setStudio(info['studio'])
            film.setCountry(info['country'])
            film.setTrailer(sys.argv[0] + '?mode=VideoInfo&vod=%s' % vod['id'])
            for part in info['videos']:
                uri = '?mode=WatchVOD&vod=%s&title=%s' % (
                    part['id'], vod['title'])
                film.addFile(uri, part['title'])
            m.addMovie(film)
            progress.update(40 + int(counter * stepSize),
                            'Processing %s' % vod['title'])
            counter += 1
            xbmc.sleep(250)
            if progress.iscanceled():
                break
        progress.update(100, 'Done')
        if not progress.iscanceled():
            __settings__.setSetting('video_last_update', datetime.datetime.fromtimestamp(
                time.time()).strftime('%Y-%m-%d %H:%M:%S'))
        progress.close()
        dialog = xbmcgui.Dialog()
        dialog.ok('VideoLibrary update', '%s files updated' % counter)
    else:
        xbmc.log('[%s] unknown movie lib command: "%s"' % (PLUGIN_NAME, do))


params = get_params()
if '_s' in params and '_sn' in params:
    SID = params['_s']
    SID_NAME = params['_sn']
else:
    SID = None
    SID_NAME = None

plugin = iptv.polbox(USERNAME, USERPASS, PLUGIN_ID, SID, SID_NAME)

def showLoginForm():
    d = xbmcgui.Dialog()
    login = d.input('Enter you login', type=xbmcgui.INPUT_NUMERIC)
    if not re.search("^\d{1,8}$", login):
        d = xbmcgui.Dialog()
        ok = d.ok("Error", "Invalid login format")
    else:
        password = d.input('Enter you password', type=xbmcgui.INPUT_NUMERIC, option=xbmcgui.ALPHANUM_HIDE_INPUT)
        if not re.search("^\d+$", password):
            d = xbmcgui.Dialog()
            ok = d.ok("Error", "Invalid password format")
        else:
            if d.ok(heading = "PolBox.TV", message = "Credentials saved"):
                    __settings__.setSetting("username", login)
                    __settings__.setSetting("password", password)

if plugin.testAuth() == False:
    showLoginForm()
else:

    if not __settings__.getSetting("timeshift"):
        values = plugin.getSettingCurrent("timeshift")
        if values:
            __settings__.setSetting("timeshift", values[0])

    if not __settings__.getSetting("bitrate"):
        values = plugin.getSettingCurrent("bitrate")
        if values:
            __settings__.setSetting("bitrate", values[0])
    
    if 'mode' in params:
        mode = params['mode']
    else:
        if __settings__.getSetting('start_with_tv') == 'false':
            mode = None
        else:
            mode = 'TV'

    if 'channel' in params:
        channel = params['channel']
    else:
        channel = None

    if 'title' in params:
        title = params['title']
    else:
        title = ''

    resetAlarms(plugin, mode)

    what = mode
    if title:
        frmt = '[LIVE] %s/'
        if 'ts' in params:
            frmt = '[ARCH] %s/'
        if 'vod' in params:
            frmt = '[VOD] %s/'
        what = frmt % title
    if what == None:
        what = 'Root'
    urlpath = what + sys.argv[2]
    extras = {}
    extras['screen'] = xbmc.getInfoLabel('System.ScreenMode')

    if mode == 'WatchTV':
        WatchTV(plugin, channel, params)

    elif mode == 'Archive':
        Archive(plugin, channel, params)

    elif mode == 'VideoLib':
        VideoLib(plugin, params)

    elif mode == 'SelectGenre':
        SelectGenres(plugin, params)

    elif mode == 'Video':
        Video(plugin, params)

    elif mode == 'VideoInfo':
        VideoInfo(plugin, params)

    elif mode == 'WatchVOD':
        WatchVOD(plugin, params)

    elif mode == 'ShowNowNextHint':
        ShowNowNextHint(plugin, channel)

    elif mode == 'openSettings':
        showLoginForm()

    elif mode in ('TV', 'FAV'):
        ShowChannelsList(plugin, mode)

    elif mode == 'Favourite':
        Favourite(plugin, channel)

    elif mode == 'Settings':
        ProcessSettings(plugin, params)

    elif mode == 'MovieLib':
        do = ''
        if 'do' in params:
            do = params['do']
        MovieLib(plugin, do)

    elif mode == 'ExecURL':
        # Get(url)
        xbmc.sleep(50)
        xbmc.executebuiltin('Container.Refresh')
    else:
        ShowRoot()
